<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item prop="feedbackType">
                <el-select v-model="queryParams.feedbackType" placeholder="请选择反馈类型" clearable>
                    <el-option v-for="dict in dict.type.feedback_type" :key="dict.value" :label="dict.label" :value="dict.value" />
                </el-select>
            </el-form-item>
            <el-form-item prop="userId">
                <el-input v-model="queryParams.userId" placeholder="请输入用户ID" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item prop="status">
                <el-select v-model="queryParams.status" placeholder="请选择反馈状态" clearable>
                    <el-option v-for="dict in dict.type.feedback_status" :key="dict.value" :label="dict.label" :value="dict.value" />
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/app/feedback/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="用户ID" align="center" prop="userId" width="200px" />
            <el-table-column label="反馈类型" align="center" prop="feedbackType" width="200px">
                <template slot-scope="scope">
                    <dict-tag :options="dict.type.feedback_type" :value="scope.row.feedbackType" />
                </template>
            </el-table-column>
            <el-table-column label="反馈状态" align="center" prop="status" width="200px">
                <template slot-scope="scope">
                    <dict-tag :options="dict.type.feedback_status" :value="scope.row.status" />
                </template>
            </el-table-column>
            <el-table-column label="反馈内容" align="center" prop="content" show-overflow-tooltip />
            <el-table-column label="回复内容" align="center" prop="feedbackResult" show-overflow-tooltip />
            <el-table-column label="创建人" align="center" prop="createBy" />
            <el-table-column label="创建时间" align="center" prop="createTime" />
            <el-table-column label="修改人" align="center" prop="updateBy" />
            <el-table-column label="修改时间" align="center" prop="createTime" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['app:feedback:edit']" v-if="scope.row.status != '1'">回复</el-button>
                    <!--          <el-button-->
                    <!--             -->
                    <!--            type="text"-->
                    <!--            icon="el-icon-delete"-->
                    <!--            @click="handleDelete(scope.row)"-->
                    <!--            v-hasPermi="['app:feedback:remove']"-->
                    <!--          >删除</el-button>-->
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改APP意见反馈对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="100px" style="margin-left: 20px; margin-right: 20px">
                    <el-col :span="24">
                        <el-form-item label="回复内容">
                            <el-input v-model="form.feedbackResult" type="textarea" placeholder="请输入回复内容" maxlength="500" :rows="8" style="width: 400px" show-word-limit />
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listFeedback, getFeedback, delFeedback, addFeedback, updateFeedback, updateFeedbackStatus } from '@/api/app/feedback'

export default {
    name: 'Feedback',
    dicts: ['feedback_type', 'feedback_status'],
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // APP意见反馈表格数据
            feedbackList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                feedbackType: null,
                content: null,
                userId: null,
                status: null
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {}
        }
    },
    created() {
        this.getList()
    },
    methods: {
        /** 查询APP意见反馈列表 */
        getList() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                feedbackType: null,
                feedbackResult: null,
                content: null,
                userId: null,
                status: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加意见反馈'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getFeedback(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '回复意见反馈'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateFeedback(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addFeedback(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除APP意见反馈编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delFeedback(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/app/feedback/export',
                {
                    ...this.queryParams
                },
                `feedback_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        },
        handleStatusChange(row) {
            let text = row.status === '0' ? '启用' : '停用'
            this.$confirm('确认要' + text + ' ' + row.name + ' 吗？')
                .then(function () {
                    return updateFeedbackStatus(row.id, row.status)
                })
                .then(() => {
                    this.$modal.msgSuccess(text + '成功')
                })
                .catch(function () {
                    row.status = row.status === '0' ? '1' : '0'
                })
        }
    }
}
</script>
